/*
Copyright 2022, Savanni D'Gerinel <savanni@luminescent-dreams.com>

This file is part of Savanni's AVR library.

Lumeto is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Lumeto is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Lumeto. If not, see <https://www.gnu.org/licenses/>.
*/

#include "rng.h"

rng_t rng_new(uint8_t seed) {
    rng_t rng = { .mod = 255, .a = 253, .c = 41, .seed = seed };
    return rng;
}

uint8_t rng_sample(rng_t *state) {
    state->seed = (state->a * state->seed + state->c) % state->mod;
    return state->seed;
}

